/**!
 * The MIT License
 *
 * Copyright (c) 2013 the angular-leaflet-directive Team, http://tombatossals.github.io/angular-leaflet-directive
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * angular-google-maps
 * https://github.com/tombatossals/angular-leaflet-directive
 *
 * @authors https://github.com/tombatossals/angular-leaflet-directive/graphs/contributors
 */

/*! angular-leaflet-directive 12-12-2013 */
!function(){"use strict";angular.module("leaflet-directive",[]).directive("leaflet",["$log","$q","leafletData","leafletMapDefaults","leafletHelpers","leafletEvents",function(a,b,c,d,e,f){var g;return{restrict:"EA",replace:!0,scope:{center:"=center",defaults:"=defaults",maxBounds:"=maxbounds",bounds:"=bounds",marker:"=marker",markers:"=markers",legend:"=legend",geojson:"=geojson",paths:"=paths",tiles:"=tiles",layers:"=layers",controls:"=controls",eventBroadcast:"=eventBroadcast",watchMarkers:"=watchmarkers"},template:'<div class="angular-leaflet-map"></div>',controller:["$scope",function(a){g=b.defer(),this.getMap=function(){return g.promise},this.getLeafletScope=function(){return a}}],link:function(b,h,i){var j=e.isDefined,k=d.setDefaults(b.defaults,i.id),l=f.genDispatchMapEvent,m=f.getAvailableMapEvents();j(b.maxBounds)&&(k.minZoom=void 0),j(i.width)&&(isNaN(i.width)?h.css("width",i.width):h.css("width",i.width+"px")),j(i.height)&&(isNaN(i.height)?h.css("height",i.height):h.css("height",i.height+"px"));var n=new L.Map(h[0],d.getMapCreationDefaults(i.id));if(g.resolve(n),j(i.center)||(a.warn("[AngularJS - Leaflet] 'center' is undefined in the current scope, did you forget to initialize it?"),n.setView([k.center.lat,k.center.lng],k.center.zoom)),!j(i.tiles)&&!j(i.layers)){var o=L.tileLayer(k.tileLayer,k.tileLayerOptions);o.addTo(n),c.setTiles(o)}if(j(n.zoomControl)&&j(k.zoomControlPosition)&&n.zoomControl.setPosition(k.zoomControlPosition),j(n.zoomControl)&&k.zoomControl===!1&&n.zoomControl.removeFrom(n),j(n.zoomsliderControl)&&j(k.zoomsliderControl)&&k.zoomsliderControl===!1&&n.zoomsliderControl.removeFrom(n),!j(i.eventBroadcast))for(var p="broadcast",q=0;q<m.length;q++){var r=m[q];n.on(r,l(b,r,p),{eventName:r})}n.whenReady(function(){c.setMap(n,i.id)})}}}]),angular.module("leaflet-directive").directive("center",["$log","$parse","leafletMapDefaults","leafletHelpers",function(a,b,c,d){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(e,f,g,h){var i=d.isDefined,j=d.safeApply,k=d.isValidCenter,l=h.getLeafletScope(),m=l.center;h.getMap().then(function(d){var e=c.getDefaults(g.id);if(i(m)){m.autoDiscover===!0&&d.locate({setView:!0,maxZoom:e.maxZoom});var f={lat:b("center.lat"),lng:b("center.lng"),zoom:b("center.zoom")}}else a.warn("[AngularJS - Leaflet] 'center' is undefined in the current scope, did you forget to initialize it?"),d.setView([e.center.lat,e.center.lng],e.center.zoom);var h=!1;l.$watch("center",function(b){return k(b)?(h||d.setView([b.lat,b.lng],b.zoom),void 0):(a.warn("[AngularJS - Leaflet] invalid 'center'"),d.setView([e.center.lat,e.center.lng],e.center.zoom),void 0)},!0),d.on("movestart",function(){h=!0}),d.on("moveend",function(){h=!1,j(l,function(a){f&&(f.lat.assign(a,d.getCenter().lat),f.lng.assign(a,d.getCenter().lng),f.zoom.assign(a,d.getZoom()))})})})}}}]),angular.module("leaflet-directive").directive("tiles",["$log","leafletData","leafletMapDefaults","leafletHelpers",function(a,b,c,d){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(e,f,g,h){var i=d.isDefined,j=h.getLeafletScope(),k=j.tiles;return i(k)||i(k.url)?(h.getMap().then(function(a){var d,e=c.getDefaults(g.id);j.$watch("tiles",function(c){var f=e.tileLayerOptions,h=e.tileLayer;return!i(c.url)&&i(d)?(a.removeLayer(d),void 0):i(d)?i(c.url)&&i(c.options)&&!angular.equals(c.options,f)?(a.removeLayer(d),f=e.tileLayerOptions,angular.copy(c.options,f),h=c.url,d=L.tileLayer(h,f),d.addTo(a),b.setTiles(d,g.id),void 0):(i(c.url)&&d.setUrl(c.url),void 0):(i(c.options)&&angular.copy(c.options,f),i(c.url)&&(h=c.url),d=L.tileLayer(h,f),d.addTo(a),b.setTiles(d,g.id),void 0)},!0)}),void 0):(a.warn("[AngularJS - Leaflet] The 'tiles' definition doesn't have the 'url' property."),void 0)}}}]),angular.module("leaflet-directive").directive("legend",["$log","leafletHelpers",function(a,b){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(c,d,e,f){var g=b.isArray,h=f.getLeafletScope(),i=h.legend;f.getMap().then(function(b){if(g(i.colors)&&g(i.labels)&&i.colors.length===i.labels.length){var c=i.legendClass?i.legendClass:"legend",d=i.position||"bottomright",e=L.control({position:d});e.onAdd=function(){for(var a=L.DomUtil.create("div",c),b=0;b<i.colors.length;b++)a.innerHTML+='<div><i style="background:'+i.colors[b]+'"></i>'+i.labels[b]+"</div>";return a},e.addTo(b)}else a.warn("[AngularJS - Leaflet] legend.colors and legend.labels must be set.")})}}}]),angular.module("leaflet-directive").directive("geojson",["$log","$rootScope","leafletData","leafletHelpers",function(a,b,c,d){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(a,e,f,g){var h=d.safeApply,i=d.isDefined,j=g.getLeafletScope(),k={};g.getMap().then(function(a){j.$watch("geojson",function(e){if(i(k)&&a.hasLayer(k)&&a.removeLayer(k),i(e)&&i(e.data)){var f=e.resetStyleOnMouseout,g=e.onEachFeature;g||(g=function(a,c){d.LabelPlugin.isLoaded()&&i(e.label)&&c.bindLabel(a.properties.description),c.on({mouseover:function(c){h(j,function(){e.selected=a,b.$broadcast("leafletDirectiveMap.geojsonMouseover",c)})},mouseout:function(a){f&&k.resetStyle(a.target),h(j,function(){e.selected=void 0,b.$broadcast("leafletDirectiveMap.geojsonMouseout",a)})},click:function(a){h(j,function(){b.$broadcast("leafletDirectiveMap.geojsonClick",e.selected,a)})}})}),e.options={style:e.style,onEachFeature:g},k=L.geoJson(e.data,e.options),c.setGeoJSON(k),k.addTo(a)}})})}}}]),angular.module("leaflet-directive").directive("layers",["$log","$q","leafletData","leafletHelpers","leafletMapDefaults","leafletLayerHelpers",function(a,b,c,d,e,f){var g;return{restrict:"A",scope:!1,replace:!1,require:"leaflet",controller:function(){g=b.defer(),this.getLayers=function(){return g.promise}},link:function(b,h,i,j){var k=d.isDefined,l=d.isDefinedAndNotNull,m={},n=j.getLeafletScope(),o=n.layers,p=f.createLayer;j.getMap().then(function(b){var d=e.getDefaults(i.id);if(a.log(d),!k(o)||!k(o.baselayers)||0===Object.keys(o.baselayers).length)return a.error("[AngularJS - Leaflet] At least one baselayer has to be defined"),void 0;g.resolve(m),c.setLayers(m,i.id),m.baselayers={},m.controls={},m.controls.layers=new L.control.layers,m.controls.layers.setPosition(d.controlLayersPosition),m.controls.layers.addTo(b);var f=!1;for(var h in o.baselayers){var j=p(o.baselayers[h]);null!==j&&(m.baselayers[h]=j,o.baselayers[h].top===!0&&(b.addLayer(m.baselayers[h]),f=!0),m.controls.layers.addBaseLayer(m.baselayers[h],o.baselayers[h].name))}!f&&Object.keys(m.baselayers).length>0&&b.addLayer(m.baselayers[Object.keys(o.baselayers)[0]]),m.overlays={};for(h in o.overlays){var q=p(o.overlays[h]);null!==q&&(m.overlays[h]=q,o.overlays[h].visible===!0&&b.addLayer(m.overlays[h]),m.controls.layers.addOverlay(m.overlays[h],o.overlays[h].name))}n.$watch("layers.baselayers",function(c){for(var d in m.baselayers)void 0===c[d]&&(m.controls.layers.removeLayer(m.baselayers[d]),b.hasLayer(m.baselayers[d])&&b.removeLayer(m.baselayers[d]),delete m.baselayers[d]);for(var e in c)if(void 0===m.baselayers[e]){var f=p(c[e]);null!==f&&(m.baselayers[e]=f,c[e].top===!0&&b.addLayer(m.baselayers[e]),m.controls.layers.addBaseLayer(m.baselayers[e],c[e].name))}if(Object.keys(m.baselayers).length<=0)a.error("[AngularJS - Leaflet] At least one baselayer has to be defined");else{var g=!1;for(var h in m.baselayers)if(b.hasLayer(m.baselayers[h])){g=!0;break}g||b.addLayer(m.baselayers[Object.keys(o.baselayers)[0]])}},!0),n.$watch("layers.overlays",function(a){for(var c in m.overlays)k(a[c])||(m.controls.layers.removeLayer(m.overlays[c]),b.hasLayer(m.overlays[c])&&b.removeLayer(m.overlays[c]),delete m.overlays[c]);for(var d in a)if(!k(m.overlays[d])){var e=p(a[d]);l(e)&&(m.overlays[d]=e,m.controls.layers.addOverlay(m.overlays[d],a[d].name),a[d].visible===!0&&b.addLayer(m.overlays[d]))}},!0)})}}}]),angular.module("leaflet-directive").directive("bounds",["$log","leafletHelpers",function(a,b){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(c,d,e,f){var g=b.isDefined,h=b.createLeafletBounds,i=f.getLeafletScope();f.getMap().then(function(b){function c(){if(i.bounds){var a=b.getBounds(),c={northEast:{lat:a.getNorthEast().lat,lng:a.getNorthEast().lng},southWest:{lat:a.getSouthWest().lat,lng:a.getSouthWest().lng}};angular.equals(i.bounds,c)||(i.bounds=c)}}function d(c){if(!g(c))return a.error("[AngularJS - Leaflet] Invalid bounds"),void 0;var d=h(c);d&&!b.getBounds().equals(d)&&b.fitBounds(d)}b.on("moveend",c),b.on("dragend",c),b.on("zoomend",c),b.whenReady(function(){i.$watch("bounds",d,!0)})})}}}]),angular.module("leaflet-directive").directive("markers",["$log","$rootScope","$q","leafletData","leafletHelpers","leafletMapDefaults","leafletEvents",function(a,b,c,d,e,f,g){return{restrict:"A",scope:!1,replace:!1,require:["leaflet","?layers"],link:function(h,i,j,k){var l=k[0],m=e,n=e.isDefined,o=e.isDefinedAndNotNull,p=e.MarkerClusterPlugin,q=e.isString,r=e.isNumber,s=e.safeApply,t=l.getLeafletScope(),u=t.markers,v=g.getAvailableMarkerEvents();l.getMap().then(function(g){var h,i=f.getDefaults(j.id),l={},w={};h=n(k[1])?k[1].getLayers:function(){var a=c.defer();return a.resolve(),a.promise};var x=L.Icon.extend({options:{iconUrl:i.icon.url,iconRetinaUrl:i.icon.retinaUrl,iconSize:i.icon.size,iconAnchor:i.icon.anchor,labelAnchor:i.icon.labelAnchor,popupAnchor:i.icon.popup,shadowUrl:i.icon.shadow.url,shadowRetinaUrl:i.icon.shadow.retinaUrl,shadowSize:i.icon.shadow.size,shadowAnchor:i.icon.shadow.anchor}});if(n(u)){var y=void 0===t.watchMarkers||"true"===t.watchMarkers||t.watchMarkers===!0;h().then(function(c){function f(d,f,g){function i(a,c){return function(e){var g="leafletDirectiveMarker."+a,h=d.replace("markers.","");"click"===a?s(t,function(){b.$broadcast("leafletDirectiveMarkersClick",h)}):"dragend"===a&&(s(t,function(){f.lat=j.getLatLng().lat,f.lng=j.getLatLng().lng}),f.message&&f.focus===!0&&j.openPopup()),s(t,function(a){"emit"===c?a.$emit(g,{markerName:h,leafletEvent:e}):b.$broadcast(g,{markerName:h,leafletEvent:e})})}}var j=h(f);if(n(f.layer)){if(!q(f.layer))return a.error("[AngularJS - Leaflet] A layername must be a string"),null;if(!o(c))return a.error("[AngularJS - Leaflet] You must add layers to the directive if used in a marker"),null;if(!o(c.overlays))return a.error("[AngularJS - Leaflet] You must add layers overlays to the directive if used in a marker"),null;if(!o(c.overlays[f.layer]))return a.error("[AngularJS - Leaflet] You must use a name of an existing layer"),null;var k=c.overlays[f.layer];if(!(k instanceof L.LayerGroup))return a.error('[AngularJS - Leaflet] A marker can only be added to a layer of type "group"'),null;k.addLayer(j),g.hasLayer(j)&&f.focus===!0&&j.openPopup()}else{if(n(f.group)){if(!p.isLoaded())return a.error("[AngularJS - Leaflet] The MarkerCluster plugin is not loaded."),void 0;n(w[f.group])||(w[f.group]=new L.MarkerClusterGroup,g.addLayer(w[f.group])),w[f.group].addLayer(j)}else g.addLayer(j);e.LabelPlugin.isLoaded()&&n(f.label)&&n(f.label.options)&&f.label.options.noHide===!0&&j.showLabel(),f.focus===!0&&j.openPopup()}var l,u,z=[],A="broadcast";if(void 0===t.eventBroadcast||null===t.eventBroadcast)z=v;else if("object"!=typeof t.eventBroadcast)a.warn("[AngularJS - Leaflet] event-broadcast must be an object check your model.");else if(void 0===t.eventBroadcast.marker||null===t.eventBroadcast.marker)z=v;else if("object"!=typeof t.eventBroadcast.marker)a.warn("[AngularJS - Leaflet] event-broadcast.marker must be an object check your model.");else{void 0!==t.eventBroadcast.marker.logic&&null!==t.eventBroadcast.marker.logic&&("emit"!==t.eventBroadcast.marker.logic&&"broadcast"!==t.eventBroadcast.marker.logic?a.warn("[AngularJS - Leaflet] Available event propagation logic are: 'emit' or 'broadcast'."):"emit"===t.eventBroadcast.marker.logic&&(A="emit"));var B=!1,C=!1;if(void 0!==t.eventBroadcast.marker.enable&&null!==t.eventBroadcast.marker.enable&&"object"==typeof t.eventBroadcast.marker.enable&&(B=!0),void 0!==t.eventBroadcast.marker.disable&&null!==t.eventBroadcast.marker.disable&&"object"==typeof t.eventBroadcast.marker.disable&&(C=!0),B&&C)a.warn("[AngularJS - Leaflet] can not enable and disable events at the same time");else if(B||C)if(B)for(l=0;l<t.eventBroadcast.marker.enable.length;l++)u=t.eventBroadcast.marker.enable[l],-1!==z.indexOf(u)?a.warn("[AngularJS - Leaflet] This event "+u+" is already enabled"):-1===v.indexOf(u)?a.warn("[AngularJS - Leaflet] This event "+u+" does not exist"):z.push(u);else for(z=v,l=0;l<t.eventBroadcast.marker.disable.length;l++){u=t.eventBroadcast.marker.disable[l];var D=z.indexOf(u);-1===D?a.warn("[AngularJS - Leaflet] This event "+u+" does not exist or has been already disabled"):z.splice(D,1)}else a.warn("[AngularJS - Leaflet] must enable or disable events")}for(l=0;l<z.length;l++)u=z[l],j.on(u,i(u,A),{eventName:u,scope_watch_name:d});if(y)var E=t.$watch(d,function(b,d){if(!o(b)){if(j.closePopup(),o(c)&&n(c.overlays))for(var e in c.overlays)c.overlays[e]instanceof L.LayerGroup&&c.overlays[e].hasLayer(j)&&c.overlays[e].removeLayer(j);return g.removeLayer(j),E(),void 0}if(n(d)){if(q(b.layer)){if(o(d.layer)||d.layer!==b.layer)if("string"==typeof d.layer&&void 0!==c.overlays[d.layer]&&c.overlays[d.layer].hasLayer(j)&&c.overlays[d.layer].removeLayer(j),j.closePopup(),g.hasLayer(j)&&g.removeLayer(j),void 0!==c.overlays[b.layer]){var f=c.overlays[b.layer];f instanceof L.LayerGroup?(f.addLayer(j),g.hasLayer(j)&&b.focus===!0&&j.openPopup()):a.error('[AngularJS - Leaflet] A marker can only be added to a layer of type "group"')}else a.error("[AngularJS - Leaflet] You must use a name of an existing layer")}else q(d.layer)&&(n(c.overlays[d.layer])&&c.overlays[d.layer].hasLayer(j)&&(c.overlays[d.layer].removeLayer(j),j.closePopup()),g.hasLayer(j)||g.addLayer(j));if(void 0===b.draggable||null===b.draggable||b.draggable!==!0?void 0!==d.draggable&&null!==d.draggable&&d.draggable===!0&&j.dragging&&j.dragging.disable():(void 0===d.draggable||null===d.draggable||d.draggable!==!0)&&(j.dragging?j.dragging.enable():L.Handler.MarkerDrag&&(j.dragging=new L.Handler.MarkerDrag(j),j.options.draggable=!0,j.dragging.enable())),void 0===b.icon||null===b.icon||"object"!=typeof b.icon)void 0!==d.icon&&null!==d.icon&&"object"==typeof d.icon&&(j.setIcon(new x),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message));else if(void 0===d.icon||null===d.icon||"object"!=typeof d.icon){var h=!1;j.dragging&&(h=j.dragging.enabled()),m.AwesomeMarkersPlugin.is(b.icon)?j.setIcon(b.icon):m.Leaflet.DivIcon.is(b.icon)||m.Leaflet.Icon.is(b.icon)?j.setIcon(b.icon):j.setIcon(new x(b.icon)),h&&j.dragging.enable(),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message)}else if(m.AwesomeMarkersPlugin.is(b.icon)){if(!m.AwesomeMarkersPlugin.equal(b.icon,d.icon)){var i=!1;j.dragging&&(i=j.dragging.enabled()),j.setIcon(b.icon),i&&j.dragging.enable(),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message)}}else if(m.Leaflet.DivIcon.is(b.icon)){if(!m.Leaflet.DivIcon.equal(b.icon,d.icon)){var k=!1;j.dragging&&(k=j.dragging.enabled()),j.setIcon(b.icon),k&&j.dragging.enable(),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message)}}else if(m.Leaflet.Icon.is(b.icon)){if(!m.Leaflet.Icon.equal(b.icon,d.icon)){var l=!1;j.dragging&&(l=j.dragging.enabled()),j.setIcon(b.icon),l&&j.dragging.enable(),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message)}}else if(JSON.stringify(b.icon)!==JSON.stringify(d.icon)){var p=!1;j.dragging&&(p=j.dragging.enabled()),j.setIcon(new x(b.icon)),p&&j.dragging.enable(),j.closePopup(),j.unbindPopup(),void 0!==b.message&&null!==b.message&&"string"==typeof b.message&&""!==b.message&&j.bindPopup(b.message)}if(void 0===b.message||null===b.message||"string"!=typeof b.message||""===b.message?void 0!==d.message&&null!==d.message&&"string"==typeof d.message&&""!==d.message&&(j.closePopup(),j.unbindPopup()):void 0===d.message||null===d.message||"string"!=typeof d.message||""===d.message?(j.bindPopup(b.message),b.focus===!0&&j.openPopup()):b.message!==d.message&&j.setPopupContent(b.message),void 0===b.focus||null===b.focus||b.focus!==!0?void 0!==d.focus&&null!==d.focus&&d.focus===!0&&j.closePopup():void 0===d.focus||null===d.focus||d.focus!==!0?j.openPopup():d.focus===!0&&b.focus===!0&&j.openPopup(),r(b.lat)&&r(b.lng)){var s=j.getLatLng();if(s.lat!==b.lat||s.lng!==b.lng){var t=!1;q(b.layer)&&m.MarkerClusterPlugin.is(c.overlays[b.layer])&&(c.overlays[b.layer].removeLayer(j),t=!0),j.setLatLng([b.lat,b.lng]),t&&c.overlays[b.layer].addLayer(j)}}else{if(a.warn("There are problems with lat-lng data, please verify your marker model"),o(c)&&o(c.overlays))for(var u in c.overlays)(c.overlays[u]instanceof L.LayerGroup||m.MarkerClusterPlugin.is(c.overlays[u]))&&c.overlays[u].hasLayer(j)&&c.overlays[u].removeLayer(j);g.removeLayer(j)}}},!0);return j}function h(a){var b=null;b=a.icon?a.icon:new x;var c={icon:b,draggable:a.draggable?!0:!1,clickable:n(a.clickable)?a.clickable:!0,riseOnHover:n(a.riseOnHover)?a.riseOnHover:!1};a.title&&(c.title=a.title);var d=new L.marker(a,c);return a.message&&d.bindPopup(a.message),e.LabelPlugin.isLoaded()&&n(a.label)&&n(a.label.message)&&d.bindLabel(a.label.message,a.label.options),d}d.setMarkers(l,j.id),t.$watch("markers",function(a){function b(a){var b=l[a];if(b.closePopup(),o(c)&&n(c.overlays))for(var d in c.overlays)c.overlays[d]instanceof L.LayerGroup&&c.overlays[d].hasLayer(b)&&c.overlays[d].removeLayer(b);if(o(w))for(var e in w)w[e].hasLayer(b)&&w[e].removeLayer(b);g.removeLayer(b),delete l[a]}var d=!n(a);for(var e in l){var h=!n(a[e]);(d||h)&&b(e)}for(var i in a)if(!n(l[i])){var j=f("markers."+i,a[i],g);null!==j&&(l[i]=j)}},y)})}})}}}]),angular.module("leaflet-directive").directive("paths",["$log","leafletData","leafletMapDefaults","leafletHelpers",function(a,b,c,d){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(a,e,f,g){var h=d.isDefined,i=g.getLeafletScope(),j=i.paths,k=d.convertToLeafletLatLng,l=d.convertToLeafletLatLngs,m=d.convertToLeafletMultiLatLngs;g.getMap().then(function(d){function e(b,c,d,e){function f(a){if(h(a.latlngs))switch(a.type){default:case"polyline":case"polygon":g.setLatLngs(l(a.latlngs));break;case"multiPolyline":case"multiPolygon":g.setLatLngs(m(a.latlngs));break;case"rectangle":g.setBounds(new L.LatLngBounds(l(a.latlngs)));break;case"circle":case"circleMarker":g.setLatLng(k(a.latlngs)),h(a.radius)&&g.setRadius(a.radius)}h(a.weight)&&g.setStyle({weight:a.weight}),h(a.color)&&g.setStyle({color:a.color}),h(a.opacity)&&g.setStyle({opacity:a.opacity})}var g,i={weight:e.path.weight,color:e.path.color,opacity:e.path.opacity};switch(h(c.stroke)&&(i.stroke=c.stroke),h(c.fill)&&(i.fill=c.fill),h(c.fillColor)&&(i.fillColor=c.fillColor),h(c.fillOpacity)&&(i.fillOpacity=c.fillOpacity),h(c.smoothFactor)&&(i.smoothFactor=c.smoothFactor),h(c.noClip)&&(i.noClip=c.noClip),h(c.type)||(c.type="polyline"),c.type){default:case"polyline":g=new L.Polyline([],i);break;case"multiPolyline":g=new L.multiPolyline([[[0,0],[1,1]]],i);break;case"polygon":g=new L.Polygon([],i);break;case"multiPolygon":g=new L.MultiPolygon([[[0,0],[1,1],[0,1]]],i);break;case"rectangle":g=new L.Rectangle([[0,0],[1,1]],i);break;case"circle":g=new L.Circle([0,0],1,i);break;case"circleMarker":g=new L.CircleMarker([0,0],i)}d.addLayer(g);var j=a.$watch("paths."+b,function(a){return h(a)?(f(a),void 0):(d.removeLayer(g),j(),void 0)},!0);return g}var g=c.getDefaults(f.id);if(h(j)){var i={};b.setPaths(i,f.id),a.$watch("paths",function(a){for(var b in a)h(i[b])||(i[b]=e(b,a[b],d,g));for(var c in i)h(a[c])||delete i[c]},!0)}})}}}]),angular.module("leaflet-directive").directive("controls",["$log","leafletHelpers",function(a,b){return{restrict:"A",scope:!1,replace:!1,require:"?^leaflet",link:function(a,c,d,e){if(e){var f=b.isDefined,g=e.getLeafletScope(),h=g.controls;e.getMap().then(function(a){if(f(L.Control.Draw)&&f(h.draw)){var b=new L.Control.Draw(h.draw.options);a.addControl(b)}if(f(h.custom))for(var c=0;c<h.custom.length;c++)a.addControl(h.custom[c])})}}}}]),angular.module("leaflet-directive").directive("eventBroadcast",["$log","$rootScope","leafletHelpers","leafletEvents",function(a,b,c,d){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(b,e,f,g){var h=c.isObject,i=g.getLeafletScope(),j=i.eventBroadcast,k=d.getAvailableMapEvents(),l=d.genDispatchMapEvent;g.getMap().then(function(b){var c,d,e=[],f="broadcast";if(h(j)){if(void 0===j.map||null===j.map)e=k;else if("object"!=typeof j.map)a.warn("[AngularJS - Leaflet] event-broadcast.map must be an object check your model.");else{void 0!==j.map.logic&&null!==j.map.logic&&("emit"!==j.map.logic&&"broadcast"!==j.map.logic?a.warn("[AngularJS - Leaflet] Available event propagation logic are: 'emit' or 'broadcast'."):"emit"===j.map.logic&&(f="emit"));var g=!1,m=!1;if(void 0!==j.map.enable&&null!==j.map.enable&&"object"==typeof j.map.enable&&(g=!0),void 0!==j.map.disable&&null!==j.map.disable&&"object"==typeof j.map.disable&&(m=!0),g&&m)a.warn("[AngularJS - Leaflet] can not enable and disable events at the time");else if(g||m)if(g)for(c=0;c<j.map.enable.length;c++)d=j.map.enable[c],-1!==e.indexOf(d)?a.warn("[AngularJS - Leaflet] This event "+d+" is already enabled"):-1===k.indexOf(d)?a.warn("[AngularJS - Leaflet] This event "+d+" does not exist"):e.push(d);else for(e=k,c=0;c<j.map.disable.length;c++){d=j.map.disable[c];var n=e.indexOf(d);-1===n?a.warn("[AngularJS - Leaflet] This event "+d+" does not exist or has been already disabled"):e.splice(n,1)}else a.warn("[AngularJS - Leaflet] must enable or disable events")}for(c=0;c<e.length;c++)d=e[c],b.on(d,l(i,d,f),{eventName:d})}else a.warn("[AngularJS - Leaflet] event-broadcast must be an object, check your model.")})}}}]),angular.module("leaflet-directive").directive("maxbounds",["$log","leafletMapDefaults","leafletHelpers",function(a,b,c){return{restrict:"A",scope:!1,replace:!1,require:"leaflet",link:function(a,b,d,e){var f=e.getLeafletScope(),g=c.isValidBounds;e.getMap().then(function(a){f.$watch("maxBounds",function(b){return g(b)?(a.setMaxBounds(new L.LatLngBounds(new L.LatLng(b.southWest.lat,b.southWest.lng),new L.LatLng(b.northEast.lat,b.northEast.lng)),b.options),void 0):(a.setMaxBounds(),void 0)})})}}}]),angular.module("leaflet-directive").service("leafletData",["$log","$q","leafletHelpers",function(a,b,c){var d=c.getDefer,e=c.getUnresolvedDefer,f=c.setResolvedDefer,g={},h={},i={},j={},k={},l={};this.setMap=function(a,b){var c=e(g,b);c.resolve(a),f(g,b)},this.getMap=function(a){var b=d(g,a);return b.promise},this.getPaths=function(a){var b=d(j,a);return b.promise},this.setPaths=function(a,b){var c=e(j,b);c.resolve(a),f(j,b)},this.getMarkers=function(a){var b=d(k,a);return b.promise},this.setMarkers=function(a,b){var c=e(k,b);c.resolve(a),f(k,b)},this.getLayers=function(a){var b=d(i,a);return b.promise},this.setLayers=function(a,b){var c=e(i,b);c.resolve(a),f(i,b)},this.setTiles=function(a,b){var c=e(h,b);c.resolve(a),f(h,b)},this.getTiles=function(a){var b=d(h,a);return b.promise},this.setGeoJSON=function(a,b){var c=e(l,b);c.resolve(a),f(l,b)},this.getGeoJSON=function(a){var b=d(l,a);return b.promise}}]),angular.module("leaflet-directive").factory("leafletMapDefaults",["$q","leafletHelpers",function(a,b){function c(){return{keyboard:!0,dragging:!0,worldCopyJump:!1,doubleClickZoom:!0,scrollWheelZoom:!0,zoomControl:!0,attributionControl:!0,zoomsliderControl:!1,layercontrol:{position:"topright",control:L.control.layers,collapsed:!0},controlLayersPosition:"topright",crs:L.CRS.EPSG3857,tileLayer:"http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",tileLayerOptions:{attribution:'&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'},icon:{url:"http://cdn.leafletjs.com/leaflet-0.6.4/images/marker-icon.png",retinaUrl:"http://cdn.leafletjs.com/leaflet-0.6.4/images/marker-icon-2x.png",size:[25,41],anchor:[12,40],labelAnchor:[10,-20],popup:[0,-40],shadow:{url:"http://cdn.leafletjs.com/leaflet-0.6.4/images/marker-shadow.png",retinaUrl:"http://cdn.leafletjs.com/leaflet-0.6.4/images/marker-shadow.png",size:[41,41],anchor:[12,40]}},path:{weight:10,opacity:1,color:"#0000ff"},center:{lat:0,lng:0,zoom:1}}}var d=b.isDefined,e=b.obtainEffectiveMapId,f={};return{getDefaults:function(a){var b=e(f,a);return f[b]},getMapCreationDefaults:function(a){var b=e(f,a),c=f[b],g={maxZoom:c.maxZoom,minZoom:c.minZoom,keyboard:c.keyboard,dragging:c.dragging,zoomControl:c.zoomControl,doubleClickZoom:c.doubleClickZoom,scrollWheelZoom:c.scrollWheelZoom,attributionControl:c.attributionControl,worldCopyJump:c.worldCopyJump,crs:c.crs};return d(c.zoomAnimation)&&(g.zoomAnimation=c.zoomAnimation),d(c.fadeAnimation)&&(g.fadeAnimation=c.fadeAnimation),d(c.markerZoomAnimation)&&(g.markerZoomAnimation=c.markerZoomAnimation),g},setDefaults:function(a,b){var g=c();d(a)&&(g.doubleClickZoom=d(a.doubleClickZoom)?a.doubleClickZoom:g.doubleClickZoom,g.scrollWheelZoom=d(a.scrollWheelZoom)?a.scrollWheelZoom:g.doubleClickZoom,g.zoomControl=d(a.zoomControl)?a.zoomControl:g.zoomControl,g.zoomsliderControl=d(a.zoomsliderControl)?a.zoomsliderControl:g.zoomsliderControl,g.attributionControl=d(a.attributionControl)?a.attributionControl:g.attributionControl,g.tileLayer=d(a.tileLayer)?a.tileLayer:g.tileLayer,g.zoomControlPosition=d(a.zoomControlPosition)?a.zoomControlPosition:g.zoomControlPosition,g.keyboard=d(a.keyboard)?a.keyboard:g.keyboard,g.dragging=d(a.dragging)?a.dragging:g.dragging,g.controlLayersPosition=d(a.controlLayersPosition)?a.controlLayersPosition:g.controlLayersPosition,d(a.crs)&&d(L.CRS[a.crs])&&(g.crs=L.CRS[a.crs]),d(a.tileLayerOptions)&&angular.copy(a.tileLayerOptions,g.tileLayerOptions),d(a.maxZoom)&&(g.maxZoom=a.maxZoom),d(a.minZoom)&&(g.minZoom=a.minZoom),d(a.zoomAnimation)&&(g.zoomAnimation=a.zoomAnimation),d(a.fadeAnimation)&&(g.fadeAnimation=a.fadeAnimation),d(a.markerZoomAnimation)&&(g.markerZoomAnimation=a.markerZoomAnimation),d(a.worldCopyJump)&&(g.worldCopyJump=a.worldCopyJump));var h=e(f,b);return f[h]=g,g}}}]),angular.module("leaflet-directive").factory("leafletEvents",["$rootScope","$q","leafletHelpers",function(a,b,c){var d=c.safeApply;return{getAvailableMapEvents:function(){return["click","dblclick","mousedown","mouseup","mouseover","mouseout","mousemove","contextmenu","focus","blur","preclick","load","unload","viewreset","movestart","move","moveend","dragstart","drag","dragend","zoomstart","zoomend","zoomlevelschange","resize","autopanstart","layeradd","layerremove","baselayerchange","overlayadd","overlayremove","locationfound","locationerror","popupopen","popupclose"]},genDispatchMapEvent:function(b,c,e){return function(f){var g="leafletDirectiveMap."+c;d(b,function(b){"emit"===e?b.$emit(g,{leafletEvent:f}):"broadcast"===e&&a.$broadcast(g,{leafletEvent:f})})}},getAvailableMarkerEvents:function(){return["click","dblclick","mousedown","mouseover","mouseout","contextmenu","dragstart","drag","dragend","move","remove","popupopen","popupclose"]},genDispatchMarkerEvent:function(b,c,e,f){return function(g){var h="leafletDirectiveMarker."+c;d(b,function(b){"emit"===e?b.$emit(h,{leafletEvent:g,markerName:f}):"broadcast"===e&&a.$broadcast(h,{leafletEvent:g,markerName:f})})}}}}]),angular.module("leaflet-directive").factory("leafletLayerHelpers",["$rootScope","$q","$log","leafletHelpers",function($rootScope,$q,$log,leafletHelpers){function createXyzLayer(a,b){return L.tileLayer(a,b)}function createWmsLayer(a,b){return L.tileLayer.wms(a,b)}function createWfsLayer(url,layerName,options){if(Helpers.WFSLayerPlugin.isLoaded()){options.crs&&"string"==typeof options.crs&&(options.crs=eval(options.crs));var layer=new L.GeoJSON.WFS(url,layerName,options);return layer}return null}function createGroupLayer(){return L.layerGroup()}function createMarkerClusterLayer(a){return Helpers.MarkerClusterPlugin.isLoaded()?new L.MarkerClusterGroup(a):null}function createGoogleLayer(a,b){return a=a||"SATELLITE",Helpers.GoogleLayerPlugin.isLoaded()?new L.Google(a,b):null}function createBingLayer(a,b){return Helpers.BingLayerPlugin.isLoaded()?new L.BingLayer(a,b):null}function createAGSLayer(a,b){if(Helpers.AGSLayerPlugin.isLoaded()){angular.extend(b,{url:a});var c=new lvector.AGS(b);return c.onAdd=function(a){this.setMap(a)},c.onRemove=function(){this.setMap(null)},c}return null}function createDynamicMapLayer(a,b){if(Helpers.DynamicMapLayerPlugin.isLoaded()){var c=L.esri.dynamicMapLayer(a,b);return c}return null}function createImageOverlay(a,b,c){return L.imageOverlay(a,b,c)}var Helpers=leafletHelpers,isString=leafletHelpers.isString;return{createLayer:function(a){if(!isString(a.type))return $log.error("[AngularJS - Leaflet] A base layer must have a type"),null;if("xyz"!==a.type&&"wms"!==a.type&&"wfs"!==a.type&&"group"!==a.type&&"markercluster"!==a.type&&"google"!==a.type&&"bing"!==a.type&&"ags"!==a.type&&"dynamic"!==a.type&&"imageOverlay"!==a.type)return $log.error('[AngularJS - Leaflet] A layer must have a valid type: "xyz, wms, wfs, group, google, ags, dynamic"'),null;if(("xyz"===a.type||"wms"===a.type||"wfs"===a.type||"imageOverlay"===a.type||"ags"===a.type||"dynamic"===a.type)&&!isString(a.url))return $log.error("[AngularJS - Leaflet] A base layer must have an url"),null;if("wfs"===a.type&&void 0===a.layer)return $log.error("[AngularJS - Leaflet] A WFS layer must have an layer"),null;if("imageOverlay"===a.type&&void 0===a.bounds&&!isString(a))return $log.error("[AngularJS - Leaflet] An imageOverlay layer must have bounds"),null;if(!isString(a.name))return $log.error("[AngularJS - Leaflet] A base layer must have a name"),null;(void 0===a.layerParams||null===a.layerParams||"object"!=typeof a.layerParams)&&(a.layerParams={}),(void 0===a.layerOptions||null===a.layerOptions||"object"!=typeof a.layerOptions)&&(a.layerOptions={});var b=null;for(var c in a.layerParams)a.layerOptions[c]=a.layerParams[c];switch(a.type){case"xyz":b=createXyzLayer(a.url,a.layerOptions);break;case"wms":b=createWmsLayer(a.url,a.layerOptions);break;case"wfs":b=createWfsLayer(a.url,a.layer,a.layerOptions);break;case"group":b=createGroupLayer();break;case"markercluster":b=createMarkerClusterLayer(a.layerOptions);break;case"google":b=createGoogleLayer(a.layerType,a.layerOptions);break;case"bing":b=createBingLayer(a.bingKey,a.layerOptions);break;case"ags":b=createAGSLayer(a.url,a.layerOptions);break;case"dynamic":b=createDynamicMapLayer(a.url,a.layerOptions);break;case"imageOverlay":b=createImageOverlay(a.url,a.bounds,a.layerOptions);break;default:b=null}return b}}}]),angular.module("leaflet-directive").factory("leafletHelpers",["$q","$log",function(a,b){function c(a,c){var d,e;if(angular.isDefined(c))d=c;else if(1===Object.keys(a).length)for(e in a)a.hasOwnProperty(e)&&(d=e);else 0===Object.keys(a).length?d="main":b.error("[AngularJS - Leaflet] - You have more than 1 map on the DOM, you must provide the map ID to the leafletData.getXXX call");return d}function d(a){return angular.isDefined(a)&&angular.isDefined(a.southWest)&&angular.isDefined(a.northEast)&&angular.isNumber(a.southWest.lat)&&angular.isNumber(a.southWest.lng)&&angular.isNumber(a.northEast.lat)&&angular.isNumber(a.northEast.lng)}function e(b,d){var e,f=c(b,d);return angular.isDefined(b[f])&&b[f].resolvedDefer!==!0?e=b[f].defer:(e=a.defer(),b[f]={defer:e,resolvedDefer:!1}),e}function f(a){return a.filter(function(a){return!!a.lat&&!!a.lng}).map(function(a){return new L.LatLng(a.lat,a.lng)})}return{isDefined:function(a){return angular.isDefined(a)},isNumber:function(a){return angular.isNumber(a)},isDefinedAndNotNull:function(a){return angular.isDefined(a)&&null!==a},isString:function(a){return angular.isString(a)},isArray:function(a){return angular.isArray(a)
},isObject:function(a){return angular.isObject(a)},equals:function(a,b){return angular.equals(a,b)},isValidCenter:function(a){return angular.isDefined(a)&&angular.isNumber(a.lat)&&angular.isNumber(a.lng)&&angular.isNumber(a.zoom)},isValidBounds:d,createLeafletBounds:function(a){return d(a)?L.latLngBounds([a.southWest.lat,a.southWest.lng],[a.northEast.lat,a.northEast.lng]):!1},convertToLeafletLatLngs:f,convertToLeafletLatLng:function(a){return new L.LatLng(a.lat,a.lng)},convertToLeafletMultiLatLngs:function(a){return a.map(function(a){return f(a)})},safeApply:function(a,b){var c=a.$root.$$phase;"$apply"===c||"$digest"===c?a.$eval(b):a.$apply(b)},obtainEffectiveMapId:c,getDefer:function(a,b){var d,f=c(a,b);return d=angular.isDefined(a[f])&&a[f].resolvedDefer!==!1?a[f].defer:e(a,b)},getUnresolvedDefer:e,setResolvedDefer:function(a,b){var d=c(a,b);a[d].resolvedDefer=!0},AwesomeMarkersPlugin:{isLoaded:function(){return void 0!==L.AwesomeMarkers?void 0!==L.AwesomeMarkers.Icon:!1},is:function(a){return this.isLoaded()?a instanceof L.AwesomeMarkers.Icon:!1},equal:function(a,b){return this.isLoaded()?this.is(a)?angular.equals(a,b):!1:!1}},LabelPlugin:{isLoaded:function(){return angular.isDefined(L.Label)},is:function(a){return this.isLoaded()?a instanceof L.MarkerClusterGroup:!1}},MarkerClusterPlugin:{isLoaded:function(){return angular.isDefined(L.MarkerClusterGroup)},is:function(a){return this.isLoaded()?a instanceof L.MarkerClusterGroup:!1}},GoogleLayerPlugin:{isLoaded:function(){return angular.isDefined(L.Google)},is:function(a){return this.isLoaded()?a instanceof L.Google:!1}},BingLayerPlugin:{isLoaded:function(){return angular.isDefined(L.BingLayer)},is:function(a){return this.isLoaded()?a instanceof L.BingLayer:!1}},WFSLayerPlugin:{isLoaded:function(){return void 0!==L.GeoJSON.WFS},is:function(a){return this.isLoaded()?a instanceof L.GeoJSON.WFS:!1}},AGSLayerPlugin:{isLoaded:function(){return void 0!==lvector&&void 0!==lvector.AGS},is:function(a){return this.isLoaded()?a instanceof lvector.AGS:!1}},DynamicMapLayerPlugin:{isLoaded:function(){return void 0!==L.esri&&void 0!==L.esri.dynamicMapLayer},is:function(a){return this.isLoaded()?a instanceof L.esri.dynamicMapLayer:!1}},Leaflet:{DivIcon:{is:function(a){return a instanceof L.DivIcon},equal:function(a,b){return this.is(a)?angular.equals(a,b):!1}},Icon:{is:function(a){return a instanceof L.Icon},equal:function(a,b){return this.is(a)?angular.equals(a,b):!1}}}}}])}();